]> git.saurik.com Git - apt.git/blob - cmdline/apt-key
- run the problemResolver after a task was installed
[apt.git] / cmdline / apt-key
1 #!/bin/sh
2
3 set -e
4
5 # We don't use a secret keyring, of course, but gpg panics and
6 # implodes if there isn't one available
7
8 GPG_CMD="gpg --ignore-time-conflict --no-options --no-default-keyring --secret-keyring /etc/apt/secring.gpg --trustdb-name /etc/apt/trustdb.gpg"
9 GPG="$GPG_CMD --keyring /etc/apt/trusted.gpg"
10
11
12 MASTER_KEYRING=/usr/share/keyrings/ubuntu-master-keyring.gpg
13 ARCHIVE_KEYRING=/usr/share/keyrings/ubuntu-archive-keyring.gpg
14 REMOVED_KEYS=/usr/share/keyrings/ubuntu-archive-removed-keys.gpg
15 ARCHIVE_KEYRING_URI=http://archive.ubuntu.com/ubuntu/project/ubuntu-archive-keyring.gpg
16
17 add_keys_with_verify_against_master_keyring() {
18 ADD_KEYRING=$1
19 MASTER=$2
20
21 if [ ! -f "$ADD_KEYRING" ]; then
22 echo "ERROR: '$ADD_KEYRING' not found"
23 return
24 fi
25 if [ ! -f "$MASTER" ]; then
26 echo "ERROR: '$MASTER' not found"
27 return
28 fi
29
30 # when adding new keys, make sure that the archive-master-keyring
31 # is honored. so:
32 # all keys that are exported and have the name
33 # "Ubuntu Archive Automatic Signing Key" must have a valid signature
34 # from a key in the ubuntu-master-keyring
35 add_keys=`$GPG_CMD --keyring $ADD_KEYRING --with-colons --list-keys | grep ^pub | cut -d: -f5`
36 master_keys=`$GPG_CMD --keyring $MASTER --with-colons --list-keys | grep ^pub | cut -d: -f5`
37 for add_key in $add_keys; do
38 ADDED=0
39 for master_key in $master_keys; do
40 if $GPG_CMD --keyring $ADD_KEYRING --list-sigs --with-colons $add_key | grep ^sig | cut -d: -f5 | grep -q $master_key; then
41 $GPG_CMD --quiet --batch --keyring $ADD_KEYRING --export $add_key | $GPG --import
42 ADDED=1
43 fi
44 done
45 if [ $ADDED = 0 ]; then
46 echo >&2 "Key '$add_key' not added. It is not signed with a master key"
47 fi
48 done
49 }
50
51 # update the current archive signing keyring from a network URI
52 # the archive-keyring keys needs to be signed with the master key
53 # (otherwise it does not make sense from a security POV)
54 net_update() {
55 if [ -z "$ARCHIVE_KEYRING_URI" ]; then
56 echo "ERROR: no location for the archive-keyring given"
57 fi
58 if [ ! -d /var/lib/apt/keyrings ]; then
59 mkdir -p /var/lib/apt/keyrings
60 fi
61 keyring=/var/lib/apt/keyrings/$(basename $ARCHIVE_KEYRING)
62 old_mtime=0
63 if [ -e $keyring ]; then
64 old_mtime=$(stat -c %Y $keyring)
65 fi
66 (cd /var/lib/apt/keyrings; wget -q -N $ARCHIVE_KEYRING_URI)
67 if [ ! -e $keyring ]; then
68 return
69 fi
70 new_mtime=$(stat -c %Y $keyring)
71 if [ $new_mtime -ne $old_mtime ]; then
72 echo "Checking for new archive signing keys now"
73 add_keys_with_verify_against_master_keyring $keyring $MASTER_KEYRING
74 fi
75 }
76
77 update() {
78 if [ ! -f $ARCHIVE_KEYRING ]; then
79 echo >&2 "ERROR: Can't find the archive-keyring"
80 echo >&2 "Is the ubuntu-keyring package installed?"
81 exit 1
82 fi
83
84 # add new keys, if no MASTER_KEYRING is used, use the traditional
85 # way
86 if [ -z "$MASTER_KEYRING" ]; then
87 $GPG_CMD --quiet --batch --keyring $ARCHIVE_KEYRING --export | $GPG --import
88 else
89 add_keys_with_verify_against_master_keyring $ARCHIVE_KEYRING $MASTER_KEYRING
90 fi
91
92 # remove no-longer supported/used keys
93 keys=`$GPG_CMD --keyring $REMOVED_KEYS --with-colons --list-keys | grep ^pub | cut -d: -f5`
94 for key in $keys; do
95 if $GPG --list-keys --with-colons | grep ^pub | cut -d: -f5 | grep -q $key; then
96 $GPG --quiet --batch --delete-key --yes ${key}
97 fi
98 done
99 }
100
101
102 usage() {
103 echo "Usage: apt-key [command] [arguments]"
104 echo
105 echo "Manage apt's list of trusted keys"
106 echo
107 echo " apt-key add <file> - add the key contained in <file> ('-' for stdin)"
108 echo " apt-key del <keyid> - remove the key <keyid>"
109 echo " apt-key export <keyid> - output the key <keyid>"
110 echo " apt-key exportall - output all trusted keys"
111 echo " apt-key update - update keys using the keyring package"
112 echo " apt-key net-update - update keys using the network"
113 echo " apt-key list - list keys"
114 echo
115 }
116
117 command="$1"
118 if [ -z "$command" ]; then
119 usage
120 exit 1
121 fi
122 shift
123
124 if [ "$command" != "help" ] && ! which gpg >/dev/null 2>&1; then
125 echo >&2 "Warning: gnupg does not seem to be installed."
126 echo >&2 "Warning: apt-key requires gnupg for most operations."
127 echo >&2
128 fi
129
130 case "$command" in
131 add)
132 $GPG --quiet --batch --import "$1"
133 echo "OK"
134 ;;
135 del|rm|remove)
136 $GPG --quiet --batch --delete-key --yes "$1"
137 echo "OK"
138 ;;
139 update)
140 update
141 ;;
142 net-update)
143 net_update
144 ;;
145 list)
146 $GPG --batch --list-keys
147 ;;
148 finger*)
149 $GPG --batch --fingerprint
150 ;;
151 export)
152 $GPG --armor --export "$1"
153 ;;
154 exportall)
155 $GPG --armor --export
156 ;;
157 adv*)
158 echo "Executing: $GPG $*"
159 $GPG $*
160 ;;
161 help)
162 usage
163 ;;
164 *)
165 usage
166 exit 1
167 ;;
168 esac